#
# ADA131757-fishing.R, 21 Jul 24
#
# Data from:
# DACS DATA COMPENDIUM SERIES
# CHRISTOPHER TURNER and GARY CARON and GINEEN BREMENT

# 172 hours per man month

tdacs=read.csv("ADA131757.csv")

# Consistency checks
rowSums(tdacs[ , grepl("Percent", colnames(tdacs))], na.rm=TRUE)
#  [1]   0 100   0 100 100 100 100   0 100 100   0   0 100   0   0 100   0   0   0
# [20] 100 100 100   0   0 100 100 100   0   0   0 100   0

tdacs$New.Source.Lines/tdacs$Programmer.Hours
#  [1]        NA  6.560804  7.799125  3.399485  6.592568  5.785363  4.813456
#  [8]        NA  4.501072        NA 21.333333  8.947593  6.410256        NA
# [15]        NA  6.587669        NA        NA        NA        NA  5.030737
# [22]        NA        NA  1.766639        NA  5.442043  2.787816        NA
# [29]        NA        NA  5.773313        NA

tdacs$New.Source.Lines/tdacs$Management.Hours
#  [1]        NA 12.333741 31.060606 18.854287 29.138524 52.219321 12.385095
#  [8]        NA 13.887919        NA 45.714286 31.979695 24.489796        NA
# [15]        NA 28.320735        NA        NA        NA        NA 22.063537
# [22]        NA        NA  6.946688        NA 72.323760  8.920360        NA
# [29]        NA        NA 19.385824        NA

tdacs$New.Source.Lines/tdacs$Manmonths.Dev.Effort
#  [1]         NA  566.81250 1025.00000  438.67265  677.83200   47.61905
#  [7]  501.87500         NA  536.04348         NA 3200.00000 1050.00000
# [13] 1200.00000         NA         NA  768.03000         NA         NA
# [19]         NA         NA  584.43396         NA         NA  204.76190
# [25]         NA  791.42857  364.21769         NA         NA         NA
# [31]   87.51818         NA

tdacs$Design_Start.Date=as.Date(tdacs$Design_Start.Date, format="%m/%d/%y")
tdacs$Design_End.Date=as.Date(tdacs$Design_End.Date, format="%m/%d/%y")

# which(tdacs$Design_Start.Date > tdacs$Design_End.Date)

tdacs$CodeTest_Start.Date=as.Date(tdacs$CodeTest_Start.Date, format="%m/%d/%y")
tdacs$CodeTest_End.Date=as.Date(tdacs$CodeTest_End.Date, format="%m/%d/%y")

# which(tdacs$CodeTest_Start.Date > tdacs$CodeTest_End.Date)

tdacs$SysTest_Start.Date=as.Date(tdacs$SysTest_Start.Date, format="%m/%d/%y")
tdacs$SysTest_End.Date=as.Date(tdacs$SysTest_End.Date, format="%m/%d/%y")

# which(tdacs$SysTest_Start.Date > tdacs$SysTest_End.Date)

tdacs$AccTest_Start.Date=as.Date(tdacs$AccTest_Start.Date, format="%m/%d/%y")
tdacs$AccTest_End.Date=as.Date(tdacs$AccTest_End.Date, format="%m/%d/%y")

# which(tdacs$AccTest_Start.Date > tdacs$AccTest_End.Date)

tdacs$Cleanup_Start.Date=as.Date(tdacs$Cleanup_Start.Date, format="%m/%d/%y")
tdacs$Cleanup_End.Date=as.Date(tdacs$Cleanup_End.Date, format="%m/%d/%y")

# which(tdacs$Cleanup_Start.Date > tdacs$Cleanup_End.Date)

# NASA.Estimate.Delivered.Object.Code is calculated from source lines
ifelse(tdacs$Delivered.Source.Lines <= 15000,
		tdacs$Delivered.Source.Lines*2.8,
		tdacs$Delivered.Source.Lines*2.1)/tdacs$NASA.Estimate.Delivered.Object.Code
ifelse(tdacs$New.Source.Lines <= 15000,
		tdacs$New.Source.Lines*2.8,
		tdacs$New.Source.Lines*2.1)/tdacs$NASA.Estimate.New.Object.Code

plot(tdacs$Programmer.Hours, tdacs$New.Source.Lines, log="xy",
	xlab="Programmer hours", ylab="New source lines")

sl_mod=glm(log(New.Source.Lines) ~ log(Programmer.Hours), data=tdacs)
summary(sl_mod)

ph_mod=glm(log(Programmer.Hours) ~ log(New.Source.Lines)+log(1e-5+Modified.Source.Lines), data=tdacs)
summary(ph_mod)


